# k8s_info – Describe Kubernetes (K8s) objects

New in version 2.7.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Use the OpenShift Python client to perform read operations on K8s objects.
- Access to the full range of K8s APIs.
- Authenticate using either a config file, certificates, password or token.
- Supports check mode.
- This module was called `k8s_facts` before Ansible 2.9. The usage did not change.

Aliases: k8s_facts

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.7
- openshift >= 0.6
- PyYAML >= 3.11

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
api_key string |  | Token used to authenticate with the API. Can also be specified via K8S_AUTH_API_KEY environment variable.
api_version - | Default: "v1" | Use to specify the API version. in conjunction with kind, name, and namespace to identify a specific object. aliases: api, version
ca_cert path |  | Path to a CA certificate used to authenticate with the API. The full certificate chain must be provided to avoid certificate validation errors. Can also be specified via K8S_AUTH_SSL_CA_CERT environment variable. aliases: ssl_ca_cert
client_cert path |  | Path to a certificate used to authenticate with the API. Can also be specified via K8S_AUTH_CERT_FILE environment variable. aliases: cert_file
client_key path |  | Path to a key file used to authenticate with the API. Can also be specified via K8S_AUTH_KEY_FILE environment variable. aliases: key_file
context string |  | The name of a context found in the config file. Can also be specified via K8S_AUTH_CONTEXT environment variable.
field_selectors - |  | List of field selectors to use to filter results
host string |  | Provide a URL for accessing the API. Can also be specified via K8S_AUTH_HOST environment variable.
kind - / required |  | Use to specify an object model. Use in conjunction with api_version, name, and namespace to identify a specific object.
kubeconfig path |  | Path to an existing Kubernetes config file. If not provided, and no other connection options are provided, the openshift client will attempt to load the default configuration file from ~/.kube/config.json. Can also be specified via K8S_AUTH_KUBECONFIG environment variable.
label_selectors - |  | List of label selectors to use to filter results
name - |  | Use to specify an object name. Use in conjunction with api_version, kind and namespace to identify a specific object.
namespace - |  | Use to specify an object namespace. Use in conjunction with api_version, kind, and name to identify a specific object.
password string |  | Provide a password for authenticating with the API. Can also be specified via K8S_AUTH_PASSWORD environment variable. Please read the description of the `username` option for a discussion of when this option is applicable.
proxy - added in 2.9 |  | The URL of an HTTP proxy to use for the connection. Can also be specified via K8S_AUTH_PROXY environment variable. Please note that this module does not pick up typical proxy settings from the environment (e.g. HTTP_PROXY).

username
string

Provide a username for authenticating with the API. Can also be specified via K8S_AUTH_USERNAME environment variable.
Please note that this only works with clusters configured to use HTTP Basic Auth. If your cluster has a different form of authentication (e.g. OAuth2 in OpenShift), this option will not work as expected and you should look into the `k8s_auth` module, as that might do what you need.

validate_certs
boolean

Choices:
- no
- yes

Whether or not to verify the API server's SSL certificates. Can also be specified via K8S_AUTH_VERIFY_SSL environment variable.
aliases: verify_ssl

## Notes

Note

- The OpenShift Python client wraps the K8s Python client, providing full access to all of the APIS and models available on both platforms. For API version details and additional information visit https://github.com/openshift/openshift-restclient-python
- To avoid SSL certificate validation errors when `validate_certs` is True, the full certificate chain for the API server must be provided via `ca_cert` or in the kubeconfig file.

## Examples

    - name: Get an existing Service object
      k8s_info:
        api_version: v1
        kind: Service
        name: web
        namespace: testing
      register: web_service

    - name: Get a list of all service objects
      k8s_info:
        api_version: v1
        kind: Service
        namespace: testing
      register: service_list

    - name: Get a list of all pods from any namespace
      k8s_info:
        kind: Pod
      register: pod_list

    - name: Search for all Pods labelled app=web
      k8s_info:
        kind: Pod
        label_selectors:
          - app = web
          - tier in (dev, test)

    - name: Search for all running pods
      k8s_info:
        kind: Pod
        field_selectors:
          - status.phase=Running

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
resources complex | success | The object(s) that exists
| api_version string | success | The versioned schema of this representation of an object.
| kind string | success | Represents the REST resource this object represents.
| metadata dictionary | success | Standard object metadata. Includes name, namespace, annotations, labels, etc.
| spec dictionary | success | Specific attributes of the object. Will vary based on the api_version and kind.
| status dictionary | success | Current status details for the object.

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Will Thames (@willthames)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.